;include 'equates\smbios.inc'

use16
org  0x0600           ;//    
jmp  @start           ;//   -

menu          db  '   Help   '
              db  ' PCI Dump '
              db  '  CPU-Id  '
              db  '  SMBIOS  '
              db  ' ATA/SATA '
              db  '  P-Mode  '
menuEnd       db  ' PowerOff '
menuLen       =   $ - menuEnd
CheckBox      db  '******'

help          db 'Key [1]. This page describes the menu items.                      '
              db 'Key [2]. Page with information about devices on the PCI bus.      '
              db 'Key [3]. CPUID and RAM physical memory allocation map.            '
              db 'Key [4]. Parse information from SMBIOS and DMI tables.            '
              db 'Key [5]. Information about the installed ATA/SATA hard drive.     '
              db 'Key [6]. Transition to CPU x64 Protected Mode with virtual memory.'
helpEnd       db 'Key [7]. You can Reboot the operating system & Power Off.         '
helpLen       =  $ - helpEnd

logo          db "  ____             _        _                             _   "
              db " / __ \           | |      | |                           | |  "
              db "| /  \/  ___    __| |  ___ | |__   _   _     _ __    ___ | |_ "
              db "| |     / _ \  / _` | / _ \| '_ \ | | | |   | '_ \  / _ \| __|"
              db "| \__/\| (_) || (_| ||  __/| |_) || |_| | _ | | | ||  __/| |_ "
              db " \____/ \___/  \__,_| \___||_.__/  \__, |(_)|_| |_| \___| \__|"
              db "                                    __/ |                     "
logoEnd       db "                                   |___/                      "
logoLen       =   $ - logoEnd

Blue          =   0001b
Green         =   0010b
Red           =   0100b
Cyan          =   0011b
Pink          =   0101b
Yellow        =   0110b
White         =   1111b
Gray          =   0111b

;//---------------------------------------------------------------
PrintString:
         push   es 0xb800
         pop    es
@@:      lodsb
         stosw
         loop   @b
         pop    es
ret
ClearScreen:
         push   es 0xb800
         pop    es
         mov    ax,' '
         mov    di,160*2
         mov    cx,80*25
         rep    stosw
         pop    es
ret
SetCheckBox:
         mov    si,CheckBox
         mov    cx,6
         mov    ah,Cyan           ;// 
         call   PrintString
ret
;----    EC    HEX ------------
PrintHex:
         pusha
         push   es 0xb800        ;
         pop    es               ;
         mov    di,[cursor]      ; ES:DI =   800:0000
         xchg   edx,ecx          ; EDX = 
         mov    ecx,[dataSize]   ; -   
@@:      shld   eax,edx,4        ;   AL  
         rol    edx,4            ;    EDX
         and    al,0x0f          ;   AL   
         cmp    al,0x0a          ;   
         sbb    al,0x69          ;    ..hex   AL
         das                     ;        ..  ASCII-
         mov    ah,Yellow        ;  
         stosw                   ;  A  
         loop   @b               ;    
         pop    es               ;
         popa
ret
;//*************************************************
align 16
@start:
;//    
         mov    di,(160)+4       ;//    ( 2)
         mov    si,menu          ;//   
         mov    cx,menuLen       ;//    
         mov    ah,00110000b     ;// :    
         mov    bp,7
@@:      push   cx
         call   PrintString      ;// !
         pop    cx
         add    di,2
         dec    bp
         jnz    @b

@HelpPage:
         call   ClearScreen
         mov    di,(160*2)+8      ;//   
         call   SetCheckBox

         mov    di,(160*4)+18     ;//   
         mov    si,logo
         mov    cx,logoLen
         mov    ah,Green          ;// 
         mov    bp,8              ;//  
@@:      push   cx di
         call   PrintString
         pop    di cx
         add    di,160
         dec    bp
         jnz    @b

         mov    di,(160*14)+8     ;//   HELP
         mov    si,help
         mov    cx,helpLen
         mov    ah,Gray           ;// 
         mov    bp,7              ;//  
@@:      push   cx di
         call   PrintString
         pop    di cx
         add    di,160
         dec    bp
         jnz    @b

@GetMenuItem:
         xor    ax,ax
         int    16h

         cmp    al,'1'
         je     @HelpPage
         cmp    al,'2'
         je     @PciDumpPage
         cmp    al,'3'
         je     @CpuidPage
         cmp    al,'4'
         je     @SmbiosPage
         cmp    al,'5'
         je     @AtaSataPage
         cmp    al,'6'
         je     @ProtectedPage
         cmp    al,'7'
         je     @RebootPage
         jmp    @GetMenuItem

;//*************************************************************
;//***********   PCI-Config-Space **************************
;//*************************************************************
align 16
@PciDumpPage:
         call   ClearScreen
         mov    di,(160*2)+30     ;//   
         call   SetCheckBox
         mov    [cursor],(160*6)+4
         call   @f
         db     ' Ven/Dev    B:D:F    Class                  BAR 0-3                Device  '
         db     '---------  --------  ------   -----------------------------------  --------'
         ;       0000:0000  00:00:00  000000   00000000 00000000 00000000 00000000
         ;       0000:0000  00:00:00  000000   00000000 00000000 00000000 00000000
cursor          dw  0
dataSize        dd  0
pciAddress      dd  0

@@:      pop    si              ;//  
         mov    di,(160*4)+4    ;//   
         mov    cx,75           ;//   
         mov    ah,Gray         ;//  
         mov    bp,2            ;//  
@@:      push   cx di
         call   PrintString
         pop    di cx
         add    di,160          ;//   .
         dec    bp
         jnz    @b

;//-----    PCI-Config-Space
         xor    bx,bx           ;// BH = Bus,  BL = Device
         xor    cx,cx           ;// CH = Func, CL = Register

@find:   call   ReadPciCfg
         cmp    eax,-1
         jnz    @deviceFound

@next:   inc    ch              ;//   
         cmp    ch,8            ;//   ???
         jnz    @find           ;//  -   
         xor    ch,ch           ;// :    

         inc    bl              ;//   
         cmp    bl,32           ;//  
         jnz    @find
         xor    bl,bl

         inc    bh              ;//   
         cmp    bh,255          ;//   
         jz     @stopFind       ;//   -  !
         jmp    @find

;//-----   EAX  PCI  /
ReadPciCfg:
         xor    eax,eax            ;//   
         mov    al,bh              ;//    
         or     ah,0x80            ;//   =1
         shl    eax,16             ;//   . 32- !
         mov    ah,bl              ;//    
         shl    ah,3               ;//   3- 
         or     ah,ch              ;//   
         mov    al,cl              ;//   .   
         and    al,11111100b       ;//  2-.  - 0/1
         mov    [pciAddress],eax   ;//    
         mov    dx,0x0CF8          ;//  CONFIG_ADDRESS
         out    dx,eax             ;//    !
         nop                       ;// ...  1- 
         mov    dx,0x0CFC          ;//  CONFIG_DATA
         in     eax,dx             ;//    !
         nop                       ;// ...  1- 
ret
@deviceFound:
         push   cx bx
         push   [cursor]
         rol    eax,16             ;// Vendor/Device
         xchg   eax,ecx
         push   ecx
         mov    [dataSize],4
         call   PrintHex
         mov    di,[cursor]        ;// 
         add    di,8
         call   GetSeparator
         pop    ecx
         shl    ecx,16
         add    [cursor],10
         mov    [dataSize],4
         call   PrintHex

;//----- Bus:Dev:Func ---------------------------
         mov    ecx,[pciAddress]
         shl    ecx,8              ;// Bus(8) =   8 
         add    [cursor],12
         mov    [dataSize],2
         call   PrintHex

         mov    di,[cursor]
         add    di,4
         call   GetSeparator

         mov    ecx,[pciAddress]
         shl    ecx,16             ;// Device(5) =   16,
         shr    ecx,3              ;//   3 
         add    [cursor],6
         mov    [dataSize],2
         call   PrintHex

         mov    di,[cursor]
         add    di,4
         call   GetSeparator

         mov    ecx,[pciAddress]
         shl    ecx,21            ;// Func(3) =   20 
         shr    ecx,5             ;//   5 
         add    [cursor],6
         mov    [dataSize],2
         call   PrintHex

;//----- Class\Subclass\Interface ---------------------------
         mov    eax,[pciAddress]
         mov    bl,2
         shl    bl,2
         mov    al,bl
         call   ReadPciConfigPort
         push   ecx
         add    [cursor],8
         mov    [dataSize],6
         call   PrintHex
         pop    eax
         shr    eax,24
         mov    [classCode],ax

;//-----  4-  BAR   ---------------------
         add    [cursor],18
         mov    bp,4
         mov    bx,4
@@:      push   bx bp
         mov    eax,[pciAddress]
         shl    bl,2
         mov    al,bl
         call   ReadPciConfigPort
         mov    [dataSize],8
         call   PrintHex
         add    [cursor],18
         pop    bp bx
         inc    bl
         dec    bp
         jnz    @b

;//-----     ------------------------
         mov    si,CodeTable
         mov    cx,16
         mov    bx,[classCode]
@@:      lodsw
         cmp    ax,bx
         jz     @foundDevString
         add    si,2
         loop   @b
@foundDevString:
         mov    si,[si]
         mov    di,[cursor]     ;//   
         add    di,2
         mov    cx,10           ;//   
         mov    ah,Green        ;//  
         call   PrintString

         pop    [cursor]
         add    [cursor],160
         pop    bx cx
         jmp    @next

@stopFind:
         jmp    @GetMenuItem

classCode       dw  0
CodeTable       dw  01,t01,02,t02,03,t03,04,t04,05,t05,06,t06,07,t07,08,t08
                dw  09,t09,10,t10,11,t11,12,t12,13,t13,14,t14,15,t15,16,t16
t01  db  'Storage   '
t02  db  'Network   '
t03  db  'Display   '
t04  db  'MultiMedia'
t05  db  'Memory    '
t06  db  'Bridge    '
t07  db  'SimpleComm'
t08  db  'Peripheria'
t09  db  'Input     '
t10  db  'Docking   '
t11  db  'CPUs      '
t12  db  'SerialBus '
t13  db  'Wireless  '
t14  db  'I/O contr '
t15  db  'Satellite '
t16  db  'Unknown   '

GetSeparator:
         push   es 0xb800
         pop    es
         mov    ah,Gray
         mov    al,':'
         stosw
         pop    es
ret
ReadPciConfigPort:
         mov    dx,0x0CF8
         out    dx,eax
         nop
         mov    dx,0x0CFC
         in     eax,dx
         nop
         xchg   eax,ecx
         nop
ret

;//*************************************************************
;//***********    CPUID  *************************
;//*************************************************************
align 16
@CpuidPage:
         call   ClearScreen
         mov    di,(160*2)+52    ;//   
         call   SetCheckBox
         mov    di,buff
         xor    eax,eax
         mov    cx,128/4
         rep    stosd

         call   @f
          db    'Name string..:'
Identf    db    'Identifier...: Family     Model     Stepping     Revision'

RegValue  db    'CR0:           CR2:           CR3:           CR4:           ESP:'
          db    'TSC:                       EFLAGS:                              '
buff      db    128 dup(0)

@@:      pop    si              ;//  
         mov    di,(160*4)+4    ;//   
         mov    cx,14           ;//   
         mov    ah,Gray         ;//  
         call   PrintString

         mov    si,Identf
         mov    di,(160*5)+4    ;//   
         mov    cx,57           ;//   
         mov    ah,Gray         ;//  
         call   PrintString

         mov    si,RegValue
         mov    di,(160*7)+4    ;//   
         mov    cx,64           ;//   
         mov    ah,Gray         ;//  
         mov    bp,2
@@:      push   cx di bp
         call   PrintString
         pop    bp di cx
         add    di,160
         dec    bp
         jnz    @b

;//-----    : EAX=80000002 ------------------
         mov    edi,buff         ;//    STOSD
         mov    eax,0x80000002   ;//<---    (2)
         mov    bp,3
@@:      push   eax
         cpuid              ;//<---   CPUID
         nop
         stosd              ;//<---      EDI
         mov    eax,ebx
         stosd
         mov    eax,ecx
         stosd
         mov    eax,edx
         stosd
         pop    eax
         inc    eax        ;//<--- ...
         dec    bp         ;//<---  -1
         jnz    @b

         mov    si,buff
         mov    di,(160*4)+34     ;//   
         mov    cx,48             ;//   
         mov    ah,Yellow         ;//  
         call   PrintString

;//----- Family/Model/Stepping: EAX=1 --------------------------------
         mov    eax,1
         cpuid
         push   eax eax eax
         shr    ax,8
         and    ax,1111b                 ;// Family
         mov    cx,ax
         shl    ecx,24
         mov    [cursor],(160*5)+48
         mov    [dataSize],2
         call   PrintHex
         pop    ecx
         shr    cx,4
         and    cx,1111b                 ;// Model
         shl    ecx,24
         mov    [cursor],(160*5)+68
         mov    [dataSize],2
         call   PrintHex
         pop    ecx
         and    cx,1111b                 ;// Stepping
         shl    ecx,24
         mov    [cursor],(160*5)+94
         mov    [dataSize],2
         call   PrintHex
         pop    ecx
         shl    ecx,4                    ;// Revision
         mov    [cursor],(160*5)+120
         mov    [dataSize],2
         call   PrintHex

;//-----      -------------------
         mov    ecx,cr0
         mov    [cursor],(160*7)+14
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,cr2
         mov    [cursor],(160*7)+44
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,cr3
         mov    [cursor],(160*7)+74
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,cr4
         mov    [cursor],(160*7)+104
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,esp
         mov    [cursor],(160*7)+134
         mov    [dataSize],8
         call   PrintHex

         rdtsc
         push   eax
         xchg   edx,ecx
         mov    [cursor],(160*8)+14
         mov    [dataSize],8
         call   PrintHex
         pop    ecx
         mov    [cursor],(160*8)+30
         mov    [dataSize],8
         call   PrintHex

         xor    ecx,ecx
         pushf
         pop    cx
         mov    [cursor],(160*8)+74
         mov    [dataSize],8
         call   PrintHex

;//-----     -------------------------
         mov    si,MemMap
         mov    di,(160*10)+4     ;//   
         mov    cx,76             ;//   
         mov    ah,Cyan           ;//  
         call   PrintString

         mov    si,memTable
         mov    di,(160*12)+28    ;//   
         mov    cx,40             ;//   
         mov    ah,Gray           ;//  
         mov    bp,2
@@:      push   cx di bp
         call   PrintString
         pop    bp di cx
         add    di,160
         dec    bp
         jnz    @b

         mov    bp,160*14
         mov    [index],0
@NextMemoryMap:
         mov    ebx,[index]
         mov    di,AddressRangeDesc
;         mov    [ExtAttributes],1       ;//     ACPI 3.0
         mov    ecx,24
         mov    edx,0x534d4150          ;//  'SMAP'
         mov    eax,0xE820
         int    15h
         or     ebx,ebx
         jz     @stopMemoryMap
         mov    [index],ebx
         cmp    [Type],1
;         jnz    @NextMemoryMap         ;//   (2)

         mov    ecx,[BaseAddrHigh]
         mov    [cursor],bp
         add    [cursor],28
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,[BaseAddrLow]
         mov    [cursor],bp
         add    [cursor],44
         mov    [dataSize],8
         call   PrintHex

         mov    ecx,[LenghtHigh]
         mov    [cursor],bp
         add    [cursor],64
         mov    [dataSize],8
         call   PrintHex
         mov    ecx,[LenghtLow]
         mov    [cursor],bp
         add    [cursor],80
         mov    [dataSize],8
         call   PrintHex

         mov    ecx,[Type]
         shl    ecx,16
         mov    [cursor],bp
         add    [cursor],100
         mov    [dataSize],4
         call   PrintHex

         mov    ebx,[Type]
         mov    si,TypeStr
         mov    cx,8
@@:      lodsw
         cmp    ax,bx
         je     @f
         add    si,2
         loop   @b
@@:      mov    si,[si]
         mov    di,bp
         add    di,112            ;//   
         mov    cx,8              ;//   
         mov    ah,Green          ;//  
         cmp    [Type],1
         jnz    @f
         or     ah,1000b
@@:      call   PrintString

         add    bp,160
         jmp    @NextMemoryMap
@stopMemoryMap:
         jmp    @GetMenuItem
;//-------------------------


MemMap    db    27 dup('-')
          db    '[ Physical Memory Map ]'
          db    27 dup('-')
memTable  db    '  Base Address         Lenght       Type'
          db    '----------------  ----------------  ----'
index     dd    0

TypeStr   dw    01,@01,02,@02,03,@03,04,@04,05,@05,06,@06,07,@07,08,@08
@01       db    '<-- Free'
@02       db    'Reserved'
@03       db    'ACPI rsv'
@04       db    'ACPI NVS'
@05       db    'BadBlock'
@06       db    'Disabled'
@07       db    'ROM Bios'
@08       db    '        '

;// https://uefi.org/htmlspecs/ACPI_Spec_6_4_html/  #15
;// https://wiki.osdev.org/Detecting_Memory_(x86)
AddressRangeDesc:
BaseAddrLow     dd  0
BaseAddrHigh    dd  0
LenghtLow       dd  0
LenghtHigh      dd  0
Type            dd  0  ;//-------+
ExtAttributes   dd  0    ;//     |
                         ;//     V
FreeMemory      = 1      ;// 
Reserved        = 2      ;// 
ACPI            = 3      ;//  ACPI
NVS             = 4      ;//     (Non Vollatile Storage)
Bad             = 5      ;//  
Disabled        = 6      ;//  
RomMemory       = 7      ;// - 
OEM             = 12     ;//  


;//*************************************************************
;//***********   SMBIOS  ***********************************
;//*************************************************************
align 16
@SmbiosPage:
         call   ClearScreen
         mov    di,(160*2)+74      ;//   
         call   SetCheckBox
         mov    dword[CurrentType],0

         push   es 0xf000          ;//   "_SM_"
         pop    es                 ;//  000F:0000  000F:FFFF
         xor    di,di
@@:      cmp    dword[es:di],'_SM_'
         je     @f
         add    di,16
         cmp    di,0xffff
         jnz    @b
         pop    es
         jmp    @exitSmBios

;//-----   SMBIOS ---------------------------------
@@:      mov    ax, [es:di+6]       ;//  SMBIOS
         ror    ax,8
         mov    ebx,[es:di+24]      ;//    DMI
         mov    dx, [es:di+22]      ;//  
         pop    es
         mov    [SmbEntry],di       ;//    _SM_
         mov    [SmbVersion],ax     ;//
         mov    [SmbSize],dx        ;//
         mov    [DmiEntry],ebx      ;//    

;//-----    ----------------------------------
         mov    si,SmBiosHeader
         mov    di,(160*4)+4      ;//   
         mov    cx,50             ;//   
         mov    ah,Gray           ;//  
         mov    bp,3
@@:      push   di cx bp
         call   PrintString
         pop    bp cx di
         add    di,160
         dec    bp
         jnz    @b

         mov    si,MotherBoard
         mov    di,(160*7)+4      ;//   
         mov    cx,12             ;//   
         mov    ah,Gray           ;//  
         mov    bp,17
@@:      push   di cx bp
         call   PrintString
         pop    bp cx di
         add    di,160
         dec    bp
         jnz    @b

;//-----       --------------------------
         mov    ax,[SmbVersion]
         shr    ax,8                    ;// Major
         mov    di,(160*4)+30
         mov    [Color],Yellow
         call   HexToDec
         mov    ax,[SmbVersion]
         and    ax,0xff
         cmp    al,8
         jnz    @f
         mov    [BoardType],1
@@:      mov    di,(160*4)+34           ;// Minor
         call   HexToDec

         mov    ecx,[DmiEntry]          ;// TableEntryPoint
         mov    [cursor],(160*4)+64
         mov    [dataSize],8
         call   PrintHex

         mov    di,(160*4)+106         ;//   SMBIOS
         mov    ax,[SmbSize]
         call   HexToDec
         mov    si,bytes
         mov    ah,Yellow
         mov    cx,5
         call   PrintString

;//-----      ---------------
         mov    eax,[DmiEntry]
         mov    si,ax
         shr    eax,4
         and    ax,0xf000
         mov    [TableSegment],ax
         mov    [CurrentType],si

;//----- Type(0) = BIOS info -----------------------------------
         push   ds [TableSegment]
         pop    ds
         movzx  cx,byte[ds:si+9]   ;//   ROM-BIOS
         mov    bx,[ds:si+20]      ;//   Major/Minor
         push   cx bx
         movzx  ax,byte[ds:si+1]   ;//  
         add    si,ax              ;//   

         mov    ah,Yellow
         mov    di,(160*5)+30      ;//   
         push   di
         mov    cx,2               ;// -   
         mov    bp,1               ;//  : 0=, 1=
         call   GetSmBiosString    ;//   Award/AMI/Phoenix
         pop    di
         add    di,160

         mov    cx,1
         mov    bp,1
         call   GetSmBiosString    ;// 
         pop    ax cx
         pop    ds
         push   cx

         add    di,18
         push   ax                 ;// 
         and    ax,0xff            ;// Major
         mov    [Color],Yellow
         call   HexToDec
         mov    si,point
         mov    ah,Gray
         mov    cx,1
         call   PrintString
         pop    ax
         shr    ax,8               ;// Minor
         call   HexToDec

         pop    ax                 ;//   ROM
         inc    ax
         mov    bx,64
         mul    bx
         mov    di,(160*6)+106     ;//   
         call   HexToDec
         mov    si,kBt
         mov    ah,Yellow
         mov    cx,3
         call   PrintString


;//----- Type(1) = MotherBoard ---------------------------------
;// Board    1  2.
;//   SMBIOS(2.8)  (2),   (1)
@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @CpuType4
         cmp    bl,[BoardType]     ;//  (1)
         jnz    @b

         mov    si,[CurrentType]
         push   ds [TableSegment]
         pop    ds
         xor    ax,ax
         mov    al,[ds:si+1]       ;//  
         add    si,ax              ;//   
         mov    ah,Yellow
         mov    di,(160*8)+30      ;//   
         push   di
         mov    cx,1               ;// -   
         mov    bp,1
         call   GetSmBiosString    ;//  .
         pop    di
         add    di,160
         mov    cx,2
         mov    bp,1
         call   GetSmBiosString    ;//  .
         pop    ds

;//----- Type(4) = Processor ---------------------------------
@CpuType4:
@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @memoryType17
         cmp    bl,4               ;//  (1)
         jnz    @b

         mov    si,[CurrentType]
         push   ds [TableSegment]
         pop    ds
         xor    ax,ax
         mov    al,[ds:si+1]       ;//  
         add    si,ax              ;//   
         mov    ah,Yellow
         mov    di,(160*11)+30     ;//   
         push   di
         mov    cx,2               ;// -   
         mov    bp,1
         call   GetSmBiosString
         pop    di
         add    di,160
         mov    cx,1               ;// -   
         mov    bp,1
         call   GetSmBiosString
         pop    ds

;//-----  
         mov    si,[CurrentType]
         push   ds [TableSegment]
         pop    ds
         mov    ax,word[ds:si+18]    ;// BusClock
         mov    bx,word[ds:si+22]    ;// Speed
         mov    ch,byte[ds:si+35]    ;// CoreCount
         mov    cl,byte[ds:si+37]    ;// ThreadCount
         mov    dl,byte[ds:si+25]    ;// Socket
         pop    ds
         push   dx cx bx

         mov    [Color],Yellow
         mov    di,(160*13)+30
         push   di
         call   HexToDec      ;// BusClock
         mov    ah,Yellow
         mov    cx,4
         mov    si,mHz
         call   PrintString
         pop    di
         add    di,160

         pop    ax            ;// Speed
         push   di
         call   HexToDec
         mov    ah,Yellow
         mov    cx,4
         mov    si,mHz
         call   PrintString
         pop    di
         add    di,160

         pop    ax            ;// AH = Cores, AL = Threads
         push   ax
         shr    ax,8
         push   di
         call   HexToDec      ;// Cores
         pop    di
         add    di,160

         pop    ax
         and    ax,0xFF
         push   di
         call   HexToDec      ;// Threads
         pop    di
         add    di,160
         mov    [cursor],di

         pop    bx            ;// Socket
         and    bx,0xff
         mov    si,SocketTable
         mov    cx,30
@findSocket:
         lodsw
         cmp    ax,bx
         je     @socketFound
         add    si,2
         loop   @findSocket
         sub    si,2
@socketFound:
         mov    si,[si]
         mov    di,[cursor]
         mov    ah,Yellow
         mov    cx,7
         call   PrintString


;//----- Type(17) = MemoryDevice ----------------------------
@memoryType17:
@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @exitSmBios
         cmp    bl,17               ;//  (17)
         jnz    @b

         mov    si,[CurrentType]
         mov    di,[cursor]        ;//   
         add    di,160*2
         mov    [cursor],di

         push   ds [TableSegment]
         pop    ds
         xor    bx,bx
         mov    bl,[ds:si+1]       ;//  
         add    si,bx              ;//   

         mov    ah,Yellow
         mov    cx,2               ;// -   
         mov    bp,0               ;// BP=0 
         call   GetSmBiosString
         mov    cx,3               ;// -   
         mov    bp,1               ;// BP=1 
         call   GetSmBiosString
         pop    ds

@nextMemoryType:
         mov    si,[CurrentType]
         mov    di,[cursor]        ;//   
         add    di,160
         mov    [cursor],di

         push   ds [TableSegment]
         pop    ds
         mov    ax,[ds:si+12]      ;// MemSize
         pop    ds
         push   bx
         call   HexToDec
         mov    si,mBt
         mov    ah,Yellow
         mov    cx,3
         call   PrintString

@@:      call   FindSmBiosType
         cmp    bl,127
         jz     @exitSmBios
         cmp    bl,17               ;//  (17)
         jnz    @b
         jmp    @nextMemoryType

@exitSmBios:
         jmp    @GetMenuItem

align 4
SmbVersion      dw  0
SmbEntry        dw  0
SmbSize         dw  0

DmiEntry        dd  0
TableSegment    dw  0
TableOffset     dw  0

BoardType       db  2
CurrentType     dw  0
StrLenght       dw  0
Color           db  0

SmBiosHeader    db  'SMBIOS ver : 0.0  EntryPoint: 00000000  TableSize:'  ; Byte    ; c(4), (35)
                db  'BIOS Vendor:                                      '  ; Type(0),
                db  '       Data:             Release:         RomSize:'

MotherBoard     db  '            ' ; Type(2), c(07), (12), (17)
                db  'MotherBoard:'
                db  '    Product:'
                db  '            ' ; Type(4), c(10)
                db  'Processor  :' ; Intel Dual Core
                db  '    Product:' ; xxxxxx
                db  '    BusFreq:' ; 0000 MHz
                db  '      Speed:' ; 0000 MHz
                db  '      Cores:' ; 2
                db  '    Threads:' ; 2
                db  '     Socket:' ; LGA1366
                db  '            '
                db  'DDR-SDRAM  :' ; Type(17), c(19)
                db  '    DIMM #1:'
                db  '    DIMM #2:'
                db  '    DIMM #3:'
                db  '    DIMM #4:'

mHz    db ' MHz'
mBt    db ' MB'
kBt    db ' KB'
bytes  db ' Byte'
point  db '.'
dpoint db ':'
slash  db '/'
equal  db '='

SocketTable     dw  0x15,@15,0x19,@19,0x1d,@1d,0x1e,@1e,0x1f,@1f,0x20,@20,0x21,@21,0x22,@22,0x23,@23,0x24,@24
                dw  0x25,@25,0x26,@26,0x2b,@26,0x2c,@2c,0x2d,@2d,0x2e,@2e,0x2f,@2f,0x30,@30,0x32,@32,0x33,@33
                dw  0x34,@34,0x35,@35,0x36,@36,0x39,@39,0x3a,@3a,0x3b,@3b,0x3c,@3c,0x3d,@3d,0x3e,@3e,0x01,@Unk  ;30
@15   db  'LGA775 '
@19   db  'LGA1366'
@1d   db  'LGA1156'
@1e   db  'LGA1567'
@1f   db  'PGA988A'
@20   db  'BGA1288'
@21   db  'PGA988B'
@22   db  'BGA1023'
@23   db  'BGA1224'
@24   db  'LGA1155'
@25   db  'LGA1356'
@26   db  'LGA2011'
@2c   db  'LGA1356'
@2d   db  'LGA1150'
@2e   db  'BGA1168'
@2f   db  'BGA1234'
@30   db  'BGA1364'
@32   db  'LGA1151'
@33   db  'BGA1356'
@34   db  'BGA1440'
@35   db  'BGA1515'
@36   db  'LGA3647'
@39   db  'LGA2066'
@3a   db  'BGA1392'
@3b   db  'BGA1510'
@3c   db  'BGA1528'
@3d   db  'LGA4189'
@3e   db  'LGA1200'
@Unk  db  'Unknown'

align 4
GetSmBiosString:              ;// : SI = , DI =   
         push   es 0xb800     ;// CX = - , BP = (1)  (0)
         pop    es            ;//  /
@prn:    lodsb                ;//    DS:SI
         or     al,al         ;//  - ?
         jz     @f            ;//  -  
         or     bp,bp         ;//  ?
         jz     @prn          ;// ..
@true:   stosw                ;//  ,   
         jmp    @prn          ;//
@@:      or     bp,bp
         jz     @f
         mov    al,'.'        ;//  , -
         stosw                ;//
         add    di,2          ;// 
@@:      dec    cx            ;//   -1
         jnz    @prn          ;// ,   .
         pop    es            ;//
ret

align 4
FindSmBiosType:
         push   ds
         mov    si,[CurrentType]     ;//     
         mov    ds,[TableSegment]    ;//  SMBIOS
         xor    ax,ax                ;//
         mov    al,byte[ds:si+1]     ;//  
         mov    bl,byte[ds:si]       ;//   
         add    si,ax                ;//     
@@:      lodsb                       ;//  ..
         or     al,al                ;//  ? ( )
         jnz    @b                   ;//  -  
         cmp    al,byte[ds:si]       ;// :  .  
         jnz    @b                   ;//  -   (  )
         inc    si                   ;//
         mov    bl,byte[ds:si]       ;// : BL =  .
         pop    ds                   ;//
         mov    [CurrentType],si     ;//    !
ret

align 4
HexToDec:
         push   es 0xb800
         pop    es
         xor    ecx,ecx
         mov    ebx,10
@isDiv:  xor    edx,edx
         div    ebx
         push   edx
         inc    ecx
         or     al,al
         jnz    @isDiv
@isOut:  pop    eax
         add    al,'0'
         mov    ah,[Color]
         stosw
         loop   @isOut
         pop    es
ret


;//*************************************************************
;//***********    ATA/SATA  **************************
;//*************************************************************
align 16
@AtaSataPage:
         call   ClearScreen
         mov    di,(160*2)+96      ;//   
         call   SetCheckBox
         nop
         jmp    @GetMenuItem


;//*************************************************************
;//***********   Protected x64 Mode  ***********************
;//*************************************************************
align 16
@ProtectedPage:
         call   ClearScreen
         mov    di,(160*2)+118     ;//   
         call   SetCheckBox
         nop
         jmp    @GetMenuItem


;//*************************************************************
;//***********   REBOOT  ***********************************
;//*************************************************************
align 16
@RebootPage:
         mov    ax,5307h     ;// ATX Power Of
         mov    bx,1
         mov    cx,3
         int    15h
         int    19h          ;//    0000:700

